# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/00_core.ipynb.

# %% auto 0
__all__ = ['get_id', 'merge_pr']

# %% ../nbs/00_core.ipynb 2
from ghapi.all import GhApi
import requests, os
from fastcore.all import call_parse

# %% ../nbs/00_core.ipynb 3
def get_id(owner,repo,pull_number):
    "Get the node id of the PR"
    api = GhApi(owner, repo)
    pr = api.pulls.get(pull_number)
    return pr.node_id

# %% ../nbs/00_core.ipynb 7
def _mk_query(node_id):
    query = """mutation MyMutation {{
        enablePullRequestAutoMerge(input: {{pullRequestId: "{}", mergeMethod: MERGE}}) {{
            clientMutationId
             }}
    }}
    """.format(pr.node_id)
    return {'query': query}

# %% ../nbs/00_core.ipynb 8
def _get_query(owner,repo,pull_number):
    return _mk_query(get_id(owner,repo,pull_number))

# %% ../nbs/00_core.ipynb 9
@call_parse
def merge_pr(owner,repo,pull_number):
    token = os.getenv('GITHUB_TOKEN')
    assert token, 'You must set the GITHUB_TOKEN'
    query = _get_query(owner,repo,pull_number)
    headers = {'Authorization': f'Bearer {token}'}
    return requests.post(url="https://api.github.com/graphql",
              json={'query': query}, headers=headers)
